> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Retrieve a rating detail

GET https://rest.test.zuora.com/object-query/rating-details/{key}

Retrieves a single rating detail by ID.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/object-query/object-queries/query-rating-detail-by-key

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `key` (string, required)

### Query parameters

- `pageSize` (integer, optional, default: 10) — The maximum number of results to return in a single page. If the specified `pageSize` is less than 1 or greater than 99, Zuora will return a 400 error.
- `cursor` (string, optional) — A cursor for use in pagination. A cursor defines the starting place in a list. For instance, if you make a list request and receive 100 objects, ending with `next_page=W3sib3JkZXJ=`, your subsequent call can include `cursor=W3sib3JkZXJ=` in order to fetch the next page of the list.
- `sort[]` (list of string, optional) — A case-insensitive query parameter that specifies the sort order of the list, which can be either ascending (e.g. `id.ASC`) or descending (e.g. `id.DESC`). Supported sortable fields: - `id` - `invoiceitemid` - `creditmemoitemid`
- `expand[]` (list of string, optional) — Allows you to expand responses by including related object information in a single call. This operation does not have expandable fields.
- `filter[]` (list of string, optional) — A case-insensitive filter on the list. Supported filterable fields: - `id` - `invoiceitemid` - `creditmemoitemid` You can also filter on custom fields using the format `customField__c`.
- `fields[]` (list of string, optional) — A case-insensitive query parameter that allows you to specify which fields are returned in the response.
- `includeNullFields` (boolean, optional, default: false) — Specifies whether to include fields with the `null` value in the response. - If set to `true`, all fields will be returned in the response, including those with the `null` value. - If set to `false`, only fields with non-null values will be returned.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

## Response

### 200

OK

- `id` (string, optional) — The unique identifier of the Rating Detail.
- `invoiceItemId` (string, optional) — The unique identifier of the Invoice Item this Rating Detail is associated to.
- `creditMemoItemId` (string, optional, nullable) — The unique identifier of the Credit Memo Item this Rating Detail is associated to.
- `chargeType` (string, optional) — The type of charge of the associated Invoice Item.
- `chargeModel` (string, optional) — The charge model of the associated Invoice Item.
- `formula` (string, optional) — Text with mathematical formula used to rate the amount.
- `calculation` (string, optional) — Details of the rating done by replacing values in the formula.
- `calculatedAmount` (double, optional) — The output result of the rating calculation.
- `currency` (string, optional) — The currency code of the calculated amount.
- `unitOfMeasure` (string, optional) — Unit of measure if it's a usage charge.
- `quantity` (double, optional, nullable) — If usage charge, quantity of usages.
- `billedQuantity` (double, optional, nullable) — For on-demand usage charges, previously billed quantity in the same billing period.
- `billedAmount` (double, optional, nullable) — For on-demand usage charges, previously billed amount in the same billing period.
- `isProration` (boolean, optional) — True if the billing period is a prorated period.
- `isCredit` (boolean, optional) — True if this is a credit.
- `listPriceBase` (string, optional) — List price base from the rate plan charge.
- `billingCycleDay` (integer, optional) — Billing cycle day from the rate plan charge.
- `billingCycleType` (string, optional) — Billing cycle type from the rate plan charge.
- `billingPeriod` (string, optional) — Billing period from the rate plan charge.
- `specificBillingPeriod` (string, optional) — Specific billing period from the rate plan charge.
- `validityPeriodType` (string, optional) — Validity period type for prepaid or commitment charges.
- `billingPeriodAlignment` (string, optional) — Billing period alignment from the rate plan charge.
- `alignmentStartDate` (date, optional) — Start date used for billing alignment.
- `amountWithoutTax` (double, optional) — The amount from the Invoice Item or Credit Memo Item.
- `isInclusiveTaxNoRounding` (boolean, optional) — True if tax mode option is set to tax inclusive.
- `isProrationPartialPeriod` (boolean, optional) — True if billing rule "Prorate recurring charges for partial period?" is Yes.
- `isProrateMonthlyCharges` (boolean, optional) — True if billing rule "Bill usage/recurring charges for partial month?" is Yes.
- `isProrateWeeklyCharges` (boolean, optional) — True if billing rule "Bill usage/recurring charges for partial week?" is Yes.
- `prorationUnitRule` (string, optional) — Value of billing rule for prorating units.
- `daysInMonthRule` (string, optional) — Value of billing rule for days in a month.
- `recurringCreditProrationOptionRule` (string, optional) — Billing rule for recurring credit proration option.
- `isCreditWithOriginalCE` (boolean, optional) — True if permission for credit with original invoice item amount is enabled.
- `isProrateDiscountCredit` (boolean, optional) — True if prorated discount credit rule is enabled.
- `stackedDiscountClassApplyRule` (string, optional) — Billing rule for applying stacked discount class.
- `recurringPeriodStart` (date, optional) — Start date of the current service period.
- `recurringPeriodEnd` (date, optional) — End date of the current service period.
- `chargeStartDate` (date, optional) — Charge start date.
- `chargeEndDate` (date, optional) — Charge end date.
- `subStartDate` (date, optional) — Subscription start date.
- `subEndDate` (date, optional) — Subscription end date.
- `termStartDate` (date, optional) — Term start date.
- `termEndDate` (date, optional) — Term end date.
- `creditOption` (string, optional) — Credit option from the rate plan charge.
- `fundingPrice` (double, optional) — Total price of current validity period fund.
- `totalBalance` (double, optional) — Total fund or discount schedule balance.
- `remainingBalance` (double, optional) — Remaining fund or discount schedule balance.
- `originalBillingPeriodStart` (date, optional) — Start date of original billing period if credit.
- `originalBillingPeriodEnd` (date, optional) — End date of original billing period if credit.
- `originalAmount` (double, optional) — Original billed amount if credit.
- `basePrice` (double, optional) — Base price or fixed amount.
- `discountClass` (string, optional) — Discount class as in rate plan charge.
- `discountClassOrder` (integer, optional) — Order number of discount class.
- `discountLevel` (string, optional) — Discount level from rate plan charge.
- `discountApplySequence` (integer, optional) — Sequence in which the discount is applied.
- `discountSchedulePeriodStart` (date, optional) — Discount schedule start date.
- `discountSchedulePeriodEnd` (date, optional) — Discount schedule end date.
- `regularChargeAmount` (double, optional) — Amount of the charge that the discount is applied to.
- `regularChargeAmountLeft` (double, optional) — Remaining amount of charge before this discount is applied.
- `originalRegularChargeAmount` (double, optional) — Original amount of charge before credit.
- `discountBalanceFormula` (string, optional) — Formula used to calculate discount total balance.

## Errors

### 500 Internal Server Error

Internal server error

- `reasons` (list of CommonOqErrorResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (any, optional) — The unique identifier of the request.

### 400 Client Request Error

Invalid input

- `reasons` (list of CommonOqErrorResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (any, optional) — The unique identifier of the request.

## Types

### CommonOqErrorResponseReasonsItems

- `code` (integer, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Response**

```json
{
  "id": "rd-001",
  "invoiceItemId": "ii-123",
  "creditMemoItemId": null,
  "chargeType": "Usage",
  "chargeModel": "FlatFee",
  "formula": "UnitPrice * Quantity",
  "calculation": "10 * 5",
  "calculatedAmount": 50,
  "currency": "USD",
  "unitOfMeasure": "API Calls",
  "quantity": 5,
  "isProration": false,
  "isCredit": false,
  "amountWithoutTax": 50
}
```

**SDK Code**

```python Object Queries_queryRatingDetailByKey_example
import requests

url = "https://rest.test.zuora.com/object-query/rating-details/key"

querystring = {"fields[]":"[\"id,createddate\"]"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Object Queries_queryRatingDetailByKey_example
const url = 'https://rest.test.zuora.com/object-query/rating-details/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Object Queries_queryRatingDetailByKey_example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/object-query/rating-details/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Object Queries_queryRatingDetailByKey_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/object-query/rating-details/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Object Queries_queryRatingDetailByKey_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/object-query/rating-details/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Object Queries_queryRatingDetailByKey_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/object-query/rating-details/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Object Queries_queryRatingDetailByKey_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/object-query/rating-details/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Object Queries_queryRatingDetailByKey_example
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/object-query/rating-details/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```